<?php
//===========================================================
//  P H P  C o d e
//===========================================================
//  Create by		: Hong, Seong-Hak (euriion@pagemaker.pe.kr)
//  				: http://www.berrybox.com
//-----------------------------------------------------------
//  Creation time	: 2003-08-14 12:43
//  Update Time		: 2003-08-14 12:43
//-----------------------------------------------------------
//  Description		: 
//===========================================================

	require_once("commonlib/sb_solarlunar_lib.php");

//  ޿ ¥ ϱ ִ ȮѴ.
function er_dayofmonth($argYear, $argMonth) {
	if 	(($argMonth == 1) ||
		($argMonth == 3) ||
		($argMonth == 5) ||
		($argMonth == 7) ||
		($argMonth == 8) ||
		($argMonth == 10) ||
		($argMonth == 12)) {
		return(31);
	}
	else if	(($argMonth == 4) ||
			($argMonth == 6) ||
			($argMonth == 9) ||
			($argMonth == 11)) {
		return(30);
	}
	else {
		if (checkdate($argMonth,29,$argYear)) {
			return(29);
		}
		else {
			return(28);
		}
	}
}

//   1  Ѵ.
function er_weekdayoffirstday($argYear, $argMonth) {
	$timestamp = mktime(0,0,0,$argMonth,1,$argYear);
	return(date(w,$timestamp));
}

//     Ѵ.
function er_weekdayoflastday($argYear, $argMonth) {
	$lastday = er_dayofmonth($argYear, $argMonth);
	$timestamp = mktime(0,0,0,$argMonth,$lastday,$argYear);
	return(date(w,$timestamp));
}

//    Ͽ  ִ Ѵ.   ָ  ִ Ȯ..
function er_weekcountofmonth($argYear, $argMonth) {
	$dayofmonth = er_dayofmonth($argYear, $argMonth);
	$dayofmonth_temp = $dayofmonth + er_weekdayoffirstday($argYear, $argMonth);
	$weekcount = floor($dayofmonth_temp / 7);  //** 1 7̴.
	if (($dayofmonth_temp % 7) > 0) {
		$weekcount++;
	}
	return ($weekcount);
}

//**     ù°(κ Ͽ)  Ȯ
function er_getfirstdayofweek($argYear, $argMonth, $argWeek) {
	$weekcount = er_weekcountofmonth($argYear, $argMonth);
	if ($argWeek > $weekcount) {
		return (0);
	}
	else {
		$firstdayweek = er_weekdayoffirstday($argYear, $argMonth);
		if ($argWeek == 1) {
			return(1); //** ù°  ù°  1̴.
		}
		else {
			$firstdayofweek = 7 - $firstdayweek + 1 + (($argWeek-2)*7);
			return($firstdayofweek);
		}
	}
}

//     (κ )  Ȯ
function er_getlastdayofweek($argYear, $argMonth, $argWeek) {
	$weekcount = er_weekcountofmonth($argYear, $argMonth);
	if ($argWeek > $weekcount) {
		return (0);
	}
	else {
		$firstdayweek = er_weekdayoffirstday($argYear, $argMonth);
		$lastday = er_dayofmonth($argYear, $argMonth);
		if ($argWeek == $weekcount) {
			return($lastday); //**   ̴..
		}
		else {
			$firstdayofweek = 7 - $firstdayweek + 7 + (($argWeek-2)*7);
			return($firstdayofweek);
		}
	}
}

//   n° x  Ѵ.
function er_getdayofnweek($argYear, $argMonth, $argSeq, $argWeekday) {
	$weekcount = er_weekcountofmonth($argYear, $argMonth);
	$firstdayweek = er_weekdayoffirstday($argYear, $argMonth);
	$lastdayweek = er_weekdayoflastday($argYear, $argMonth);
	$lastday = er_dayofmonth($argYear, $argMonth);

	$resultday = 7 - $firstdayweek + 1 + $argWeekday + (($argSeq-2)*7);
	if ($resultday < 1) {
		return(0);
	}
	else if ($resultday > $lastday) {
		return(0);
	}
	return($resultday);
}

//   n° x  Ѵ.
function er_getdayofseqweek($argYear, $argMonth, $argSeq, $argWeekday) {
	$weekcount = er_weekcountofmonth($argYear, $argMonth);
	$firstdayweek = er_weekdayoffirstday($argYear, $argMonth);
	$lastdayweek = er_weekdayoflastday($argYear, $argMonth);
	$lastday = er_dayofmonth($argYear, $argMonth);

	if ($argSeq != 9) { //** ° ƴϸ...
		if ($argWeekday < $firstdayweek) {//**   ״ ι° ֺ ϸ...
			$resultday = 7 - $firstdayweek + 1 + $argWeekday + (($argSeq-2+1)*7);
		}
		else {
			$resultday = 7 - $firstdayweek + 1 + $argWeekday + (($argSeq-2)*7);
		}
	}
	else {//** ...
		if ($argWeekday > $lastdayweek) {//**   ״ ι° ֺ ϸ...
			$resultday = 7 - $firstdayweek + 1 + $argWeekday + (($weekcount-2-1)*7);
		}
		else {
			$resultday = 7 - $firstdayweek + 1 + $argWeekday + (($weekcount-2)*7);
		}
	}

	if ($resultday < 1) {
		return(0);
	}
	else if ($resultday > $lastday) {
		return(0);
	}
	return($resultday);
}

//  ¥ ° ֿ ԵǾ ȮѴ.
function er_seqweekofday($argYear, $argMonth, $argDay) {
	if (checkdate($argMonth, $argDay, $argYear)) {
		$weekcount = er_weekcountofmonth($argYear, $argMonth);
		$firstdayweek = er_weekdayoffirstday($argYear, $argMonth);
		$lastday = er_dayofmonth($argYear, $argMonth);
		$timestamp = mktime(0, 0, 0, $argMonth, $argDay, $argYear);
		$weekofday = date(w,$timestamp);

		$resultweek = floor(($firstdayweek + $argDay) / 7);
		if ((($firstdayweek + $argDay) % 7) > 0) {
			$resultweek++;
		}

		return($resultweek);
	}
	else {
		return(0);
	}
}

function er_usDate2sql($usdate) {//m-d-Y --> Y-m-d
	$usdate = str_replace("-", "/", $usdate);
	return date("Y-m-d", strtotime($usdate));
}

function er_sqlDate2us($sqldate) {//Y-m-d --> m-d-Y
	return date("m-d-Y", strtotime($sqldate));
}

function er_datediff2($arg_year,$arg_month,$arg_day, $diff)
{
	//$today=date("d-M-Y 00:00");
	//$retval = intval((strtotime($today)- strtotime("2002-01-01")) / 86400);
	$strDate = "$arg_month-$arg_day-$arg_year";
	$resulttime = strtotime($strDate) + ($diff * 86400);

	$targetdate = getdate($resulttime);
	$rmonth = $targetdate['mon'];
	$rmday = $targetdate['mday'];
	$ryear = $targetdate['year'];

	return array($ryear,$rmonth,$rmday);

	//return (date("Y-M-d", $resulttime));
}

function er_DateDiff ($interval, $date1,$date2)
{
	// get the number of seconds between the two dates
	$timedifference =  $date2 - $date1;

	switch ($interval) {
		case "w":
			$retval  = bcdiv($timedifference ,604800);
			break;
		case "d":
			$retval  = bcdiv( $timedifference,86400);
			break;
		case "h":
		 	$retval = bcdiv ($timedifference,3600);
			break;
		case "n":
			$retval  = bcdiv( $timedifference,60);
			break;
		case "s":
			$retval  = $timedifference;
			break;
	}
	return $retval;
}

function er_DateAdd ($interval, $number, $date)
{
	$date_time_array  = getdate($date);

	$hours =  $date_time_array["hours"];
	$minutes =  $date_time_array["minutes"];
	$seconds =  $date_time_array["seconds"];
	$month =  $date_time_array["mon"];
	$day =  $date_time_array["mday"];
	$year =  $date_time_array["year"];

	switch ($interval) {
		case "yyyy":
			$year +=$number;
			break;
		case "q":
			$year +=($number*3);
			break;
		case "m":
			$month +=$number;
			break;
		case "y":
		case "d":
		case "w":
			$day+=$number;
			break;
		case "ww":
			$day+=($number*7);
			break;
		case "h":
			$hours+=$number;
			break;
		case "n":
			$minutes+=$number;
			break;
		case "s":
			$seconds+=$number;
			break;
    }
	$timestamp =  mktime($hours ,$minutes, $seconds,$month ,$day, $year);
	return $timestamp;
}


//  ͸ ҷ´.
function er_load_holiday($arg_Year) {
	$temp_holiday_list;
	$holiday_filename = "./data/holiday.cgi";
	$holiday_file = fopen($holiday_filename,"r");
	$holiday_data = fread($holiday_file, filesize($holiday_filename));
	fclose($holiday_file);
	$holiday_row = explode("\n", $holiday_data);
	$holiday_row_count = count($holiday_row);
	for ($Increment = 0 ; $Increment < $holiday_row_count ; $Increment++) {
		$field = explode("|", $holiday_row[$Increment]);
		if (("$field[1]" == "1") || ("$field[1]" == "2")) {//** / ⺻
			if (strlen("$field[0]") > 4) {//** Ű ϰ...
				$key = substr("$field[0]",0,5);
				$keyMonth = substr("$field[0]",1,2);
				$keyDay = substr("$field[0]",3,2);
			}

			if (($keyMonth == "01") && ($keyDay == "01") && ("$field[1]" == "2")) {//   ġ .
				$solarDate = Lunar2Solar($arg_Year, $keyMonth, $keyDay, false);
				$solarYear = substr($solarDate,0,4);
				$solarMonth = substr($solarDate,5,2);
				$solarDay = substr($solarDate,8,2);

				$temptimestamp = er_DateAdd("d",-1,strtotime("$solarYear-$solarMonth-$solarDay"));
				$temptime = getdate($temptimestamp);
				$pyear = $temptime["year"];
				$pmonth = $temptime["mon"];
				$pday = $temptime["mday"];

				if ($pmonth < 10) {$pmonth = "0$pmonth"; };
				if ($pday < 10) {$pday = "0$pday"; };
				$key2 = "+$pmonth$pday";
				//echo "<!--ġ $arg_Year-$keyMonth-$keyDay => $solarYear-$solarMonth-$solarDay => $pyear-$pmonth-$pday-->\n";
				if ($temp_holiday_list["$key2"] == "") {
					$temp_holiday_list["$key2"] = "$field[2]|$field[3]";
				}
				else {
					$temp_holiday_list["$key2"] = $temp_holiday_list["$key2"] . "^" . "$field[2]|$field[3]";
				}
			}

			if ($temp_holiday_list["$key"] == "") {
				$temp_holiday_list["$key"] = "$field[2]|$field[3]";
			}
			else {
				$temp_holiday_list["$key"] = $temp_holiday_list["$key"] . "^" . "$field[2]|$field[3]";
			}
		}
		else if ("$field[1]" == "3") {// n° n ϴ 
			if (strlen("$field[0]") > 4) {
				$key = substr("$field[0]",0,5);
				$keyMonth = substr("$field[0]",1,2);
				$keySeq = substr("$field[0]",3,1);
				$keyWeek = substr("$field[0]",4,1);
			}

			$keyDay = er_getdayofseqweek($arg_Year, $keyMonth, $keySeq, $keyWeek);
			if($keyDay < 10) { $keyDay = "0$keyDay";};

			if ($temp_holiday_list["$key"] == "") {
				$temp_holiday_list["$key"] = "$field[2]|$field[3]";
			}
			else {
				$temp_holiday_list["$key"] = $temp_holiday_list["$key"] . "^" . "$field[2]|$field[3]";
			}
		}
		else if ("$field[1]" == "4") {//** x xϷκ ° 
			if (strlen("$field[0]") > 6) {
				$key = substr("$field[0]",0,5);
				$keyMonth = substr("$field[0]",1,2);
				$keyDay = substr("$field[0]",3,2);
				$keyPlus = substr("$field[0]",6,strlen("$field[0]") - 6);
			}

			$pYear = $arg_Year - 1;
			$keyTimeStamp = er_DateAdd("d", $keyPlus, strtotime("$pYear-$keyMonth-$keyDay"));
			$KeyDay = getdate($keyTimeStamp);
			$ryear = $KeyDay["year"];
			$rmonth = $KeyDay["mon"];
			$rday = $KeyDay["mday"];

			if ($rmonth < 10) {$rmonth = "0$rmonth"; };
			if ($rday < 10) {$rday = "0$rday"; };

			$key = "+" . "$rmonth$rday";

			if ($temp_holiday_list["$key"] == "") {
				$temp_holiday_list["$key"] = "$field[2]|$field[3]";
			}
			else {
				$temp_holiday_list["$key"] = $temp_holiday_list["$key"] . "^" . "$field[2]|$field[3]";
			}
		}
		/*
		else if ("$field[1]" == "2") //**  ⺻
		{
			if (strlen("$field[0]") > 4)
			{
				$lunMonth = substr("$field[0]",1,2);
				$lunDay = substr("$field[0]",3,2);
			}
			$solarDate = Lunar2Solar($arg_Year, $lunMonth, $lunDay, false);
			if(strlen("$solarDate") > 4)
			{
				$tempMonth = substr("$solarDate",5,2);
				$tempDay = substr("$solarDate",8,2);
			}

			$key = "$tempMonth$tempDay";
			echo "\n<!--SLSL: $lunMonth-$lunDay = $tempMonth-$tempDay -->\n";
			if ($temp_holiday_list["$key"] == "") {
				$temp_holiday_list["$key"] = "$field[2]|$field[3]";
			}
			else {
				$temp_holiday_list["$key"] = $temp_holiday_list["$key"] . "^" . "$field[2]|$field[3]";
			}
		}
		*/
	}
	return $temp_holiday_list;
}

// Ŀ  εѴ.
function er_load_userschedule($arg_Year) {
	$temp_holiday_list;
	$holiday_filename = "./data/${arg_Year}.cgi";
	if (!file_exists($holiday_filename)) {
		$holiday_file = fopen($holiday_filename,"w");
		fclose($holiday_file);
		chmod($holiday_filename,0777);
	}
	$holiday_file = fopen($holiday_filename,"r");
	$holiday_data = fread($holiday_file, filesize($holiday_filename));
	fclose($holiday_file);
	$holiday_row = explode("\n", $holiday_data);
	$holiday_row_count = count($holiday_row);
	for ($Increment = 0 ; $Increment < $holiday_row_count ; $Increment++) {
		$field = explode("|", $holiday_row[$Increment]);
		if (("$field[2]" == "1") || ("$field[2]" == "2")) {//**  Ǵ Ϻ ϱ  
			if (strlen("$field[0]") == 4) {
				$key1 = substr("$field[0]",0,4);
				$key1Month = substr("$field[0]",0,2);
				$key1Day = substr("$field[0]",2,2);
			}

			if ($temp_holiday_list["$key1"] == "") {
				$temp_holiday_list["$key1"] = "$field[1]|$field[2]|$field[3]|$field[4]";
			}
			else {
				$temp_holiday_list["$key1"] = $temp_holiday_list["$key1"] . "^" . "$field[1]|$field[2]|$field[3]|$field[4]";
			}
			// echo "\n<!-- $key1=$field[1]|$field[2]|$field[3]|$field[4] -->";
		}
	}
	return $temp_holiday_list;
}
?>